var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,uselessCode} checked by tsc
 */
import { ChangeDetectionStrategy, Component, EventEmitter, Input, Output } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormLayoutService, DynamicFormValidationService, DynamicFormControlComponent, DynamicRatingModel } from "@ss-dynamic-forms/core";
var DynamicBootstrapRatingComponent = /** @class */ (function (_super) {
    __extends(DynamicBootstrapRatingComponent, _super);
    function DynamicBootstrapRatingComponent(layoutService, validationService) {
        var _this = _super.call(this, layoutService, validationService) || this;
        _this.layoutService = layoutService;
        _this.validationService = validationService;
        _this.blur = new EventEmitter();
        _this.change = new EventEmitter();
        _this.focus = new EventEmitter();
        return _this;
    }
    DynamicBootstrapRatingComponent.decorators = [
        { type: Component, args: [{
                    selector: "dynamic-bootstrap-rating",
                    template: "<ng-container [formGroup]=\"group\">\r\n\r\n    <rating [formControlName]=\"model.id\"\r\n            [id]=\"elementId\"\r\n            [max]=\"model.max\"\r\n            [ngClass]=\"getClass('element', 'control')\"\r\n            [readonly]=\"model.getAdditional('readonly', false)\"\r\n            (onHover)=\"onCustomEvent($event, 'onHover')\"\r\n            (onLeave)=\"onCustomEvent($event, 'onLeave')\"></rating>\r\n\r\n</ng-container>\r\n",
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    DynamicBootstrapRatingComponent.ctorParameters = function () { return [
        { type: DynamicFormLayoutService },
        { type: DynamicFormValidationService }
    ]; };
    DynamicBootstrapRatingComponent.propDecorators = {
        group: [{ type: Input }],
        layout: [{ type: Input }],
        model: [{ type: Input }],
        blur: [{ type: Output }],
        change: [{ type: Output }],
        focus: [{ type: Output }]
    };
    return DynamicBootstrapRatingComponent;
}(DynamicFormControlComponent));
export { DynamicBootstrapRatingComponent };
if (false) {
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.group;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.layout;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.model;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.blur;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.change;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.focus;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.layoutService;
    /** @type {?} */
    DynamicBootstrapRatingComponent.prototype.validationService;
}
//# sourceMappingURL=dynamic-bootstrap-rating.component.js.map